unit plazaUnit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Menus, jpeg;

type

  TDisplayThread = class(TThread)        // wtek odwierzajacy
    procedure show;
    procedure execute; override;
  end;

  TSimulationThread = class(TThread)    // watek symulujacy
    FCycle : integer;
    FShark : integer;
    FHuman : integer;
    procedure execute; override;
  end;

  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Plik1: TMenuItem;
    Za1: TMenuItem;
    Wczytaj1: TMenuItem;
    Zapisz1: TMenuItem;
    N1: TMenuItem;
    Koniec1: TMenuItem;
    Dane1: TMenuItem;
    Symulacja1: TMenuItem;
    Rozpocznij1: TMenuItem;
    Przerwij1: TMenuItem;
    Zakocz1: TMenuItem;
    Okna1: TMenuItem;
    Mapa1: TMenuItem;
    Minimapa1: TMenuItem;
    Komunikaty1: TMenuItem;
    Statystyka1: TMenuItem;
    Image1: TImage;
    Obiekty1: TMenuItem;
    Symulacja2: TMenuItem;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    Timer2: TTimer;
    procedure Mapa1Click(Sender: TObject);     // Okna->Mapa
    procedure Minimapa1Click(Sender: TObject);  // Okna->Minimapa
    procedure FormCreate(Sender: TObject);  // kopiuje obrazek i tworzy wtki
    procedure FormShow(Sender: TObject);  // uruchamia watek odswierzajacy
    procedure Symulacja2Click(Sender: TObject);  // dane->Symulacja
    procedure Obiekty1Click(Sender: TObject);  // Dane->Obiekty
    procedure Koniec1Click(Sender: TObject);    // Plik->Koniec
    procedure Za1Click(Sender: TObject);     // Plik->Nowy
    procedure Zapisz1Click(Sender: TObject);   // Plik->Zapisz
    procedure Wczytaj1Click(Sender: TObject);   // Plik->Wczytaj
    procedure Rozpocznij1Click(Sender: TObject);  // Symulacja->Wznow
    procedure Przerwij1Click(Sender: TObject);   // Symulacja->Wstrzymaj
    procedure Zakocz1Click(Sender: TObject);   // Symulacja->Zakoncz
    procedure Statystyka1Click(Sender: TObject);  // Onka->Statystyka
    procedure Komunikaty1Click(Sender: TObject);  // Okna->Komunikaty
    procedure Timer2Timer(Sender: TObject);   // aktualizacja okienka "statystyka"
  private
    display : TDisplayThread;
    simulation : TSimulationThread;
  public
  end;

var
  Form1: TForm1;

implementation

uses plazaUnit2, plazaUnit3, wymianadanych, plazaUnit4, plazaUnit5,
  plazaUnit6, plazaUnit7;

{$R *.dfm}

procedure TForm1.Mapa1Click(Sender: TObject);
begin
  Form2.show;
  Form2.ActualizeWnd;
end;

procedure TForm1.Minimapa1Click(Sender: TObject);
begin
  Form3.show;
  Form3.ActualizeWnd;
end;

{ TDisplayThread }

procedure TDisplayThread.execute;
var last : integer;
begin
  last:=GetTickCount;
  repeat
    if GetTickCount-last>=odswiezanie then
      begin
        last:=getTickCount;
        synchronize(show)
      end
  until terminated;
end;

procedure TDisplayThread.show;
begin
  Form2.ActualizeWnd;
  Form3.ActualizeWnd;
end;

procedure TForm1.FormCreate(Sender: TObject);
var zm1,zm2 : integer;
begin
  for zm1:=0 to 799 do
    for zm2:=0 to 1199 do
      canv[zm1,zm2]:=Map.Bitmap.Canvas.Pixels[zm1,zm2];
  Randomize;
  display:=TDisplayThread.Create(true);
  simulation:=TSimulationThread.Create(true);
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  display.Resume;
end;

procedure TForm1.Symulacja2Click(Sender: TObject);
begin
  Form4.showmodal;
end;

procedure TForm1.Obiekty1Click(Sender: TObject);
begin
  Form2.Close;
  Form3.Close;
  Form5.showmodal;
end;

procedure TForm1.Koniec1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Za1Click(Sender: TObject);
var i : integer;
begin
  px:=0;
  py:=0;
  krok:=100;
  odswiezanie:=1000;
  alert:=false;
  for i:=0 to Length(obs)-1 do obs[i].Destroy;
  for i:=0 to length(lod)-1 do lod[i].Destroy;
  for i:=0 to length(czl)-1 do czl[i].Destroy;
  for i:=0 to length(rek)-1 do rek[i].Destroy;
  SetLength(obs,0);
  SetLength(czl,0);
  SetLength(lod,0);
  SetLength(rek,0);
  rekiny.czestosc:=15;
  rekiny.maxpop:=5;
  rekiny.predkosc:=30;
  rekiny.zasieg:=300;
  ludzie.czestosc:=10;
  ludzie.maxpop:=40;
  ludzie.predkosc:=20;
  ludzie.zasieg:=50;
end;

procedure TForm1.Zapisz1Click(Sender: TObject);
var f : textFile;
    i : integer;
begin
  if SaveDialog1.Execute then
    begin
      assignfile(f,SaveDialog1.FileName);
      rewrite(f);
      writeln(f,krok);
      writeln(f,odswiezanie);
      writeln(f,ludzie.czestosc);
      writeln(f,ludzie.maxpop);
      writeln(f,ludzie.predkosc);
      writeln(f,ludzie.zasieg);
      writeln(f,rekiny.czestosc);
      writeln(f,rekiny.maxpop);
      writeln(f,rekiny.predkosc);
      writeln(f,rekiny.zasieg);
      writeln(f,Length(obs));
      for i:=0 to Length(obs)-1 do
        writeln(f,obs[i].x,' ',obs[i].y,' ',obs[i].zasieg);
      writeln(f,Length(lod));
      for i:=0 to Length(lod)-1 do
        writeln(f,lod[i].srcx,' ',lod[i].srcy,' ',lod[i].destx,' ',lod[i].desty,
          ' ',lod[i].predkosc,' ',lod[i].zasieg);
      closefile(f);
    end;
end;

procedure TForm1.Wczytaj1Click(Sender: TObject);
var f : textFile;
    i,c : integer;
begin
  if OpenDialog1.Execute then
    begin
      for i:=0 to Length(obs)-1 do obs[i].Destroy;
      for i:=0 to length(lod)-1 do lod[i].Destroy;
      SetLength(obs,0);
      SetLength(lod,0);
      assignfile(f,OpenDialog1.FileName);
      reset(f);
      readln(f,krok);
      readln(f,odswiezanie);
      readln(f,ludzie.czestosc);
      readln(f,ludzie.maxpop);
      readln(f,ludzie.predkosc);
      readln(f,ludzie.zasieg);
      readln(f,rekiny.czestosc);
      readln(f,rekiny.maxpop);
      readln(f,rekiny.predkosc);
      readln(f,rekiny.zasieg);
      readln(f,c);
      SetLength(obs,c);
      for i:=0 to c-1 do
        begin
          obs[i]:=TObserwator.Create;
          Readln(f,obs[i].x,obs[i].y,obs[i].zasieg);
        end;
      readln(f,c);
      SetLength(lod,c);
      for i:=0 to c-1 do
        begin
          lod[i]:=TLodz.Create;
          Readln(f,lod[i].srcx,lod[i].srcy,lod[i].destx,lod[i].desty,
            lod[i].predkosc,lod[i].zasieg);
          lod[i].x:=lod[i].srcx;
          lod[i].y:=lod[i].srcy;
          lod[i].dir:=true;
        end;
      closefile(f);
    end;
end;

procedure TForm1.Rozpocznij1Click(Sender: TObject);
begin
  simulation.FCycle:=getTickCount;
  simulation.FShark:=GetTickCount;
  simulation.FHuman:=GetTickCount;
  if Za1.Enabled then
    begin
      FTime:=0;
      FObs:=Length(obs);
      FLod:=Length(lod);
      FRek:=0;
      FCzl:=0;
      FRekRip:=0;
      FCzlRip:=0;
    end;
  Form6.Aktualizuj;
  Form7.StringGrid1.RowCount:=0;
  Za1.Enabled:=false;
  Wczytaj1.Enabled:=False;
  Zapisz1.Enabled:=false;
  Obiekty1.Enabled:=false;
  Rozpocznij1.Enabled:=false;
  Przerwij1.Enabled:=true;
  Zakocz1.Enabled:=true;
  Komunikaty1.Enabled:=true;
  Statystyka1.Enabled:=true;
  Form6.Show;
  Form7.Show;
  simulation.Resume;
end;

procedure TForm1.Przerwij1Click(Sender: TObject);
begin
  Obiekty1.Enabled:=true;
  Rozpocznij1.Enabled:=true;
  Przerwij1.Enabled:=false;
  Simulation.Suspend;
end;

procedure TForm1.Zakocz1Click(Sender: TObject);
var i : integer;
begin
  Za1.Enabled:=true;
  Wczytaj1.Enabled:=true;
  Zapisz1.Enabled:=true;
  Obiekty1.Enabled:=true;
  Rozpocznij1.Enabled:=true;
  Przerwij1.Enabled:=false;
  Zakocz1.Enabled:=false;
  Komunikaty1.Enabled:=false;
  Statystyka1.Enabled:=false;
  if Simulation.Suspended then Simulation.Resume;
  Simulation.Terminate;
  Simulation.WaitFor;
  for i:=0 to Length(lod)-1 do
    begin
      lod[i].dir:=true;
      lod[i].x:=lod[i].srcx;
      lod[i].y:=lod[i].srcy;
    end;
  for i:=0 to Length(rek)-1 do rek[i].Destroy;
  for i:=0 to Length(czl)-1 do czl[i].Destroy;
  SetLength(rek,0);
  SetLength(czl,0);
  SetLength(wiadomosci,0);
  Simulation.Destroy;
  Simulation:=TSimulationThread.Create(true);
  loop:=0;
end;

{ TSimulationThread }

procedure TSimulationThread.execute;
var x,y : integer;
    i : integer;
    ok : boolean;
begin
  repeat
    if (GetTickCount-FHuman>ludzie.czestosc*1000) and (FCzl<ludzie.maxpop) then
      begin
        FHuman:=GetTickCount;
        repeat
          x:=random(Map.Width);
          y:=random(Map.Height);
          ok:=true;
          for i:=0 to Length(czl)-1 do
            if (abs(x-czl[i].x)<10) and (abs(y-czl[i].y)<10) then ok:=false;
          for i:=0 to Length(obs)-1 do
            if (abs(x-obs[i].x)<10) and (abs(y-obs[i].y)<10) then ok:=false;
        until ({Map.Bitmap.Canvas.Pixels}canv[x,y]=RGB(0,128,0)) and ok;
        SetLength(czl,Length(czl)+1);
        czl[Length(czl)-1]:=TCzlowiek.Create;
        czl[Length(czl)-1].x:=x;
        czl[Length(czl)-1].y:=y;
        czl[Length(czl)-1].killed:=false;
        inc(FCzl);
        SetLength(wiadomosci,Length(wiadomosci)+1);
        wiadomosci[Length(wiadomosci)-1]:=
          floattostr(FTime/1000)+': pojawi sie czowiek na ('+inttostr(x)+
            ','+inttostr(y)+').';
      end; 
    if (GetTickCount-FShark>rekiny.czestosc*1000) and (FRek<rekiny.maxpop) then
      begin
        FShark:=GetTickCount;
        repeat
          x:=random(Map.Width);
          y:=random(Map.Height);
        until {Map.Bitmap.Canvas.Pixels}canv[x,y]=RGB(0,0,255);
        SetLength(rek,Length(rek)+1);
        rek[Length(rek)-1]:=TRekin.Create;
        rek[Length(rek)-1].x:=x;
        rek[Length(rek)-1].y:=y;
        rek[Length(rek)-1].killed:=false;
        rek[Length(rek)-1].seen:=0;
        inc(FRek);
        SetLength(wiadomosci,Length(wiadomosci)+1);
        wiadomosci[Length(wiadomosci)-1]:=
          floattostr(FTime/1000)+': pojawi sie rekin na ('+inttostr(x)+
            ','+inttostr(y)+').';
      end;
    if GetTickCount-FCycle>krok then
      begin
        inc(loop);
        FTime:=FTime+GetTickCount-FCycle;
        FCycle:=GetTickCount;
        for i:=0 to Length(lod)-1 do lod[i].check;
        for i:=0 to Length(lod)-1 do lod[i].Move; 
        for i:=0 to Length(rek)-1 do rek[i].Move;  
        for i:=0 to Length(czl)-1 do czl[i].Move; 
        alert:=false;
        for i:=0 to length(obs)-1 do obs[i].check;
      end;
  until Terminated;
end;

procedure TForm1.Statystyka1Click(Sender: TObject);
begin
  Form6.show;
end;

procedure TForm1.Komunikaty1Click(Sender: TObject);
begin
  Form7.show;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
var i : integer;
begin
  Form6.Aktualizuj;
  Form7.StringGrid1.RowCount:=Form7.StringGrid1.RowCount+Length(wiadomosci);
  for i:=0 to Length(wiadomosci)-1 do
    Form7.StringGrid1.Cells[0,Form7.StringGrid1.RowCount-Length(wiadomosci)+i-1]:=
      wiadomosci[i];
  Form7.StringGrid1.Rows[Form7.StringGrid1.RowCount-1].Text:='';
  Setlength(wiadomosci,0);
end;

end.

